
package com.topcoder.message.im;
import java.util.*;

/**
 * <p>Message abstract class serves as a base class for messages to transport across the network. It subclasses MessagingObject and holds base information as sender, recipient(s) and timestamp. The sender and recipient or a message are left as Object type for flexibility (could be String or Long or anything). The abstract class does not define anything and carry the message itself. It is intended to be subclassed. Message is the type a connection can send and receive.</p>
 * 
 */
public abstract class Message extends com.topcoder.message.im.MessagingObject {

/**
 * <p>Sender of the Message. It is object type and can be anything that identifies a sender (needs to be serializable in order to transport). It is mutable with setter and getter.</p>
 * 
 */
    private Object sender = null;

/**
 * <p>A list of recipients of the Message. Recipient is object type and can be anything that identifies a recipient (needs to be serializable in order to transport). It is mutable with manipulation methods. It is initialized to an ArrayList. It is manipulated in methods related to recipients.</p>
 * 
 */
    private java.util.List recipients = new ArrayList();

/**
 * <p>The timestamp for the Message. It is initialized to a new Date instance which is the time the message is composed. However it has setter and getter and can be overriden.</p>
 * 
 */
    private java.util.Date timestamp = new Date();

/**
 * <p>Default constructor. Does nothing.</p>
 * 
 * 
 * 
 */
    protected  Message() {        
        // your code here
    } 

/**
 * <p>Get the sender of the message. Simply return sender field.</p>
 * 
 * 
 * 
 * 
 * @return sender of the message
 */
    public Object getSender() {        
        // your code here
        return null;
    } 

/**
 * <p>Set the sender of the message. Set the value to sender field.</p>
 * 
 * 
 * 
 * 
 * @param sender sender of the message
 * @exception NullPointerException if sender is null
 */
    public void setSender(Object sender) {        
        // your code here
    } 

/**
 * <p>Get all the recipients of the message. Return a shallow copy of the recipients field.</p>
 * 
 * 
 * 
 * 
 * @return a shallow copy of the recipients of the message
 */
    public java.util.List getAllRecipients() {        
        // your code here
        return null;
    } 

/**
 * <p>Add a recipient to the message. It simply adds the recipient to the message. (Still added even if the recipient is already in the list.)</p>
 * 
 * 
 * 
 * 
 * @param recipient the recipient to add
 * @exception NullPointerException if recipient is null
 */
    public void addRecipient(Object recipient) {        
        // your code here
    } 

/**
 * <p>Remove the recipient from the recipients list. If multiple occurrence is in the list, only the first is removed.</p>
 * 
 * 
 * 
 * 
 * @param recipient the recipient to remove
 * @exception NullPointerException if recipient is null
 */
    public void removeRecipient(Object recipient) {        
        // your code here
    } 

/**
 * <p>Check whether the recipient exists in the recipient list of the message.</p>
 * 
 * 
 * 
 * 
 * @return whether the recipient exists in the recipients list
 * @param recipient the recipient to check
 * @exception NullPointerException if recipient is null
 */
    public boolean containsRecipient(Object recipient) {        
        // your code here
        return false;
    } 

/**
 * <p>Clear all the recipients.</p>
 * 
 * 
 * 
 */
    public void clearRecipients() {        
        // your code here
    } 

/**
 * <p>Get the timestamp of the message. Return a copy of the timestamp field.</p>
 * 
 * 
 * 
 * 
 * @return timestamp of the message
 */
    public java.util.Date getTimestamp() {        
        // your code here
        return null;
    } 

/**
 * <p>Set the timestamp for the message. Set a copy of the timestamp to the timestamp field.</p>
 * 
 * 
 * 
 * 
 * @param timestamp the timestamp to set
 * @exception NullPointerException if timestamp is null
 */
    public void setTimestamp(java.util.Date timestamp) {        
        // your code here
    } 
 }
