
package com.topcoder.message.im.connection;
import com.topcoder.message.im.connection.GenericSocketConnection;

/**
 * <p>DirectSocketConnection sends message to socket on a remote address and port. It is a persistent connection. It could be used to create a chat session between two clients, or create a channel to a chat service that will distribute the messages to the named recipients.</p>
 * <p>DirectSocketConnection has an openGenericConnection() method that could create a generic connection and shares the same listener with the direct connection.</p>
 * <p>Methods should synchronize on the class instance.</p>
 * 
 */
public class DirectSocketConnection extends com.topcoder.message.im.connection.AbstractSocketConnection {

/**
 * <p>The key to retrieve the remote address in the parameter mapping. The attached parameter should be a string.</p>
 * 
 */
    public static final String REMOTE_ADDRESS_PARAM_KEY = "remote_address";

/**
 * <p>The key to retrieve the remote port in the parameter mapping. The attached parameter could be either a string or an Integer.</p>
 * 
 */
    public static final String REMOTE_PORT_PARAM_KEY = "remote_port";

/**
 * <p>The socket used to send the message. It is established in initializeConnection() and closed in closeConnection().</p>
 * 
 */
    private java.net.Socket socket = null;

/**
 * <p>Connection constructor contract. Simply propagated to super constructor.</p>
 * 
 * 
 * 
 * 
 * @param parameters the default parameters
 * @exception NullPointerException if parameters is null
 */
    public  DirectSocketConnection(java.util.Map parameters) {        
        // your code here
    } 

/**
 * <p>Create a DirectSocketConnection that listens on given port, and connects to given remote address and port. This method will create a Hashtable() and associated listeingPort to AbstractSocketConnection.LISTENING_PORT_PARAM_KEY, remoteAddress to DirectSocketConnection.REMOTE_ADDRESS_PARAM_KEY, remotePort to DirectSocketConnection.REMOTE_PORT_PARAM_KEY. Pass it to super constructor.</p>
 * 
 * 
 * 
 * 
 * @param listeningPort the port to listen for incoming messages
 * @param remoteAddress the remote address to connect to
 * @param remotePort the remote port to connect to
 * @exception NullPointerException if remoteAddress is null
 * @exception IllegalArgumentException if listeningPort or remotePort is non positive or greater than max port number, or remoteAddress is not a valid address
 */
    public  DirectSocketConnection(int listeningPort, String remoteAddress, int remotePort) {        
        // your code here
    } 

/**
 * <p>Send a message to the remote socket. If connection is not open throw ConnectionStateException. Otherwise write the message to the socket.</p>
 * 
 * 
 * 
 * 
 * @param message the message to send
 * @exception NullPointerException if message is null
 * @exception ConnectionStateException if connection is not open
 * @exception MessageSendingException if message can not be properly sent
 */
    public void sendMessage(com.topcoder.message.im.Message message) {        
        // your code here
    } 

/**
 * <p>Initialize the connection. This method will look for REMOTE_ADDRESS_PARAM_KEY and REMOTE_PORT_PARAM_KEY in the parameters mapping provided. It they do not exist or map to something invalid ConnectionInitializationException should be thrown. Otherwise it establishes the socket.</p>
 * 
 * 
 * 
 * 
 * @param parameters the initialization parameters
 * @exception NullPointerException if parameters is null
 * @exception ConnectionInitializationException if initialization fails
 */
    protected void initializeConnection(java.util.Map parameters) {        
        // your code here
    } 

/**
 * <p>Close the communication socket. If closing fails exception should be captured. super.closeConnection() will be invoked before exiting.</p>
 * 
 * 
 * 
 */
    public void closeConnection() {        
        // your code here
    } 

/**
 * <p>Open a generic connection sharing the same listener. This method will create a GenericSocketConnection with getMessageListener().getListeningPort(). Then it sets its own message listener to the created connection. It uses the no-arg openConnection() to open the created connection.</p>
 * 
 * 
 * 
 * 
 * @return a generic connection sharing the same listener
 * @exception ConnectionInitializationException if connection can not be initialized
 * @exception ConnectionStateException if connection is not open
 */
    public com.topcoder.message.im.Connection openGenericConnection() {        
        // your code here
        return null;
    } 
/**
 * <p></p>
 */
    public java.net.Socket socket;
 }
