
package com.topcoder.message.im.connection;
import com.topcoder.message.im.connection.ConnectionFactory;
import com.topcoder.util.config.ConfigManager;

/**
 * <p>Socket connection factory is an implementation that user can create socket connection with. It instantiates connection via reflection (on the constructor that takes a Map). The class name and parameters are collected from a configuration namespace with TopCoder Configuration Manager. It is thread-safe.</p>
 * 
 */
public class SocketConnectionFactory {

/**
 * <p>The default namespace that will be used for createDefaultConnection(). It is a constant and set to the fully qualified class name of the ConnectionFactory.</p>
 * 
 */
    public static final String DEFAULT_NAMESPACE = "com.topcoder.message.im.connection.SocketConnectionFactory";

/**
 * <p>The property key name of the fully qualified class name of the target connection to instantiate.</p>
 * 
 */
    public static final String CLASS_NAME_PROPERTY_KEY = "connection_class";

/**
 * <p>Default constructor. Does nothing.</p>
 * 
 * 
 * 
 */
    public  ConnectionFactory() {        
        // your code here
    } 

/**
 * <p>Create connection from specified namespace. It will collect all the properties into a parameter mapping. It does not handle multiple value properties. If a property is mapped to multiple values only the first is taken. The &quot;connection_class&quot; is also collected into the parameter mapping (in case it is useful). Then it uses the class name to reflect the connection. Anything going wrong results in ConnectionFactoryException.</p>
 * 
 * 
 * 
 * 
 * @return the connection from the namespace
 * @param namespace the namespace for configuration
 * @exception IllegalArgumentException if namespace is empty
 * @exception IllegalArgumentException if namespace is empty
 * @exception ConnectionFactoryException if it is unable to create the connection
 */
    public com.topcoder.message.im.Connection createConnection(String namespace) {        
        // your code here
        return null;
    } 

/**
 * <p>Create default connection. Simply invoke createConnection(DEFAULT_NAMESPACE).</p>
 * 
 * 
 * 
 * 
 * @return the default connection
 * @exception ConnectionFactoryException if it is unable to create the connection
 */
    public com.topcoder.message.im.Connection createDefaultConnection() {        
        // your code here
        return null;
    } 
 }
