
package com.topcoder.message.im.profile;
import com.topcoder.message.im.profile.Contact;
import com.topcoder.message.im.profile.ContactGroup;
import java.util.Comparator;

/**
 * <p>ContactComparatorBase is a comparator adapter that has type safe methods to compare contacts and contact groups. This comparator compares the contact names and group names in alphabetical order. It is intended to be subclassed.</p>
 * 
 */
public class ContactComparatorBase {

/**
 * <p>Comparator method implementation. It checks if obj1 and obj2 are both Contact instances and delegates to compareContact(), otherwise if obj1 and obj2 are both ContactGroup instances it delegates to compareGroup(). If they do not meet these ClassCastException if thrown.</p>
 * 
 * 
 * 
 * 
 * @return the comparison result
 * @param obj1 the first object
 * @param obj2 the second object
 * @exception NullPointerException if obj1 or obj2 is null
 * @exception ClassCastException if they can not be compared
 */
    public int compare(Object obj1, Object obj2) {        
        // your code here
        return 0;
    } 

/**
 * <p>Compare two contracts. It compares the name of the contracts. It is intended to be subclassed.</p>
 * 
 * 
 * 
 * 
 * @return the comparison result
 * @param contact1 the first contact
 * @param contact2 the second contract
 */
    protected int compareContact(com.topcoder.message.im.profile.Contact contact1, com.topcoder.message.im.profile.Contact contact2) {        
        // your code here
        return 0;
    } 

/**
 * <p>Compare two contract groups. It compares the name of the groups. It is intended to be subclassed.</p>
 * 
 * 
 * 
 * 
 * @return the comparison result
 * @param group1 the first group
 * @param group2 the second group
 */
    protected int compareGroup(com.topcoder.message.im.profile.ContactGroup group1, com.topcoder.message.im.profile.ContactGroup group2) {        
        // your code here
        return 0;
    } 
 }
