
package com.topcoder.message.im;
import java.io.Serializable;
import java.util.*;

/**
 * <p>MessagingObject is the base class for Message and other data oriented classes in the Instant Messaging framework. It has three purposes. The first is to act as a flag interface (however it is an abstract class). The second is to provide attribute manipulation support. The third is to implement the java.io.Serializable interface so that all subclasses can be serialized to transport on network (if that is necessary).</p>
 * <p>The attribute mapping support String keys and Object values. If the attributes are intended to be serialized they should implement Serializable as well. This base class is not thread-safe.</p>
 * 
 */
public abstract class MessagingObject {

/**
 * <p>The attribute set of the MessagingObject. Initialized to a HashMap. Its content is mutable. It is manipulated in various methods.</p>
 * 
 */
    private java.util.Map attributes = new HashMap();

/**
 * <p>Default constructor. Does nothing.</p>
 * 
 * 
 * 
 */
    protected  MessagingObject() {        
        // your code here
    } 

/**
 * <p>Get the attribute mapping as a Map. Return a shallow copy of the attributes field.</p>
 * 
 * 
 * 
 * 
 * @return a shallow copy of the attributes mapping
 */
    public java.util.Map getAllAttributes() {        
        // your code here
        return null;
    } 

/**
 * <p>Set an attribute for the MessagingObject. Delegate to attributes.put(key, value). Return the old value that is associated with the key or null if there was nothing associated.</p>
 * 
 * 
 * 
 * 
 * @return the old value associated with the mapping or null if nothing is associated
 * @param key the key of the attribute
 * @param value the value of the attribute
 * @exception NullPointerException if key or value is null
 * @exception IllegalArgumentException if key is empty
 */
    public Object setAttribute(String key, Object value) {        
        // your code here
        return null;
    } 

/**
 * <p>Get the value associated with specified key. Return attributes.get(key). If no value is attached return null.</p>
 * 
 * 
 * 
 * 
 * @return the value associated with the key, or null if no value attached
 * @param key the key of the attribute
 * @exception NullPointerException if key is null
 * @exception IllegalArgumentException if key is empty
 */
    public Object getAttribute(String key) {        
        // your code here
        return null;
    } 

/**
 * <p>Remove value associated with specified key. Use attributes.remove(key). If no value is attached, nothing happens and null is the return value.</p>
 * 
 * 
 * 
 * 
 * @return the value associated with the key
 * @param key the key of the attribute
 * @exception NullPointerException if key is null
 * @exception IllegalArgumentException if key is empty
 */
    public Object removeAttribute(String key) {        
        // your code here
        return null;
    } 

/**
 * <p>Clear all the attributes. Simply use attributes.clear().</p>
 * 
 * 
 * 
 */
    public void clearAttributes() {        
        // your code here
    } 
 }
